#if defined (_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

#ifndef JETBYTE_TOOLS_COM_T_NOTIFY_INCLUDED__
#define JETBYTE_TOOLS_COM_T_NOTIFY_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: TNotify.h $
// Version        : $Revision: 2 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 30/05/02 15:45 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /JetByteTools/COMTools/TNotify.h $
// 
// 2     30/05/02 15:45 Len
// Lint issues.
// 
// 1     22/05/02 11:05 Len
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1997 - 2002 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All 
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors 
// shall not be liable for any damages suffered by licensee as a result of 
// using, modifying or distributing the software or its derivatives. In no
// event will JetByte Limited be liable for any lost revenue, profit or data,
// or for direct, indirect, special, consequential, incidental or punitive
// damages, however caused and regardless of the theory of liability, arising 
// out of the use of or inability to use software, even if JetByte Limited 
// has been advised of the possibility of such damages.
//
// This software is not designed or intended for use in on-line control of 
// aircraft, air traffic, aircraft navigation or aircraft communications; or in 
// the design, construction, operation or maintenance of any nuclear 
// facility. Licensee represents and warrants that it will not use or 
// redistribute the Software for such purposes. 
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Lint options
//
//lint -save
//
///////////////////////////////////////////////////////////////////////////////

#include "Notify.h"

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools::COM
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {
namespace COM {
      
///////////////////////////////////////////////////////////////////////////////
// TNotify
///////////////////////////////////////////////////////////////////////////////

template <class NotifyInterface, const GUID *InterfaceIID> class TNotify : 
   private CNotify, 
   public NotifyInterface
{
   public :

		void Connect(IUnknown *pConnectTo)
		{
			CNotify::Connect(pConnectTo, *InterfaceIID, this);
		}

      using CNotify::Disconnect;
      using CNotify::Connected;

		// IUnknown methods
      ULONG STDMETHODCALLTYPE AddRef()
      {
         return 2;
      }

		ULONG STDMETHODCALLTYPE Release()
      {
         return 1;
      }

		HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, PVOID *ppvObj)
      {
	      HRESULT hr = S_OK;

	      if (riid == IID_IUnknown)
	      {
		      *ppvObj = (IUnknown *)this;
	      }
	      else if (riid == *InterfaceIID)
	      {
		      *ppvObj = (NotifyInterface *)this;
	      }
	      else
	      {
		      hr = E_NOINTERFACE;
		      *ppvObj = NULL;
	      }

	      return hr;
      }
};

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools::COM
///////////////////////////////////////////////////////////////////////////////

} // End of namespace COM
} // End of namespace JetByteTools 

///////////////////////////////////////////////////////////////////////////////
// Lint options
//
//lint -restore
//
///////////////////////////////////////////////////////////////////////////////

#endif // JETBYTE_TOOLS_COM_T_NOTIFY_ITERATOR_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
