///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: Utils.cpp $
// Version        : $Revision: 2 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 30/05/02 15:45 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /JetByteTools/COMTools/Utils.cpp $
// 
// 2     30/05/02 15:45 Len
// Lint issues.
// 
// 1     30/05/02 12:46 Len
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1997 - 2002 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All 
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors 
// shall not be liable for any damages suffered by licensee as a result of 
// using, modifying or distributing the software or its derivatives. In no
// event will JetByte Limited be liable for any lost revenue, profit or data,
// or for direct, indirect, special, consequential, incidental or punitive
// damages, however caused and regardless of the theory of liability, arising 
// out of the use of or inability to use software, even if JetByte Limited 
// has been advised of the possibility of such damages.
//
// This software is not designed or intended for use in on-line control of 
// aircraft, air traffic, aircraft navigation or aircraft communications; or in 
// the design, construction, operation or maintenance of any nuclear 
// facility. Licensee represents and warrants that it will not use or 
// redistribute the Software for such purposes. 
//
///////////////////////////////////////////////////////////////////////////////

#include "Utils.h"

///////////////////////////////////////////////////////////////////////////////
// Lint options
//
//lint -save
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools::COM
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {
namespace COM {
  
///////////////////////////////////////////////////////////////////////////////
// Functions defined in this file...
///////////////////////////////////////////////////////////////////////////////
   
bool WaitWithMessageLoop(
   HANDLE hEvent, 
   DWORD timeout /* = INFINITE */)
{
   MSG msg;
   
   //lint -e{716} while(1)
   while(1)       
   {
      DWORD dwRet = MsgWaitForMultipleObjects( 
         1,              // One event to wait for
         &hEvent,        // The array of events
         FALSE,          // Wait for 1 event
         timeout,        // Timeout value
         QS_ALLINPUT);   // Any message wakes up
       
      if(dwRet == WAIT_OBJECT_0)       
      {
         // The event was signaled, return         
         return true;
      } 
      else if(dwRet == WAIT_OBJECT_0 + 1)       
      {
         // There is a window message available. Dispatch it.
         while(PeekMessage(&msg,NULL,NULL,NULL,PM_REMOVE))       
         {
            TranslateMessage(&msg);          

            //lint -e{534} Ignoring return value of function
            DispatchMessage(&msg);
         }       
      } 
      else       
      {          // Something else happened. Return.
         return false;       
      }       
   }   
} 

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools::COM
///////////////////////////////////////////////////////////////////////////////

} // End of namespace COM
} // End of namespace JetByteTools 

///////////////////////////////////////////////////////////////////////////////
// Lint options
//
//lint -restore
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
