#if defined (_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

#ifndef JETBYTE_TOOLS_NM_CONFERENCE_MANAGER_INCLUDED__
#define JETBYTE_TOOLS_NM_CONFERENCE_MANAGER_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: NMConferenceManager.h $
// Version        : $Revision: 3 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 30/05/02 20:24 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /Web Articles/COMNotify/JetByteTools/NMTools/NMConferenceManager.h $
// 
// 3     30/05/02 20:24 Len
// We now inherit privately from TNotify
// 
// 2     30/05/02 18:20 Len
// Lint issues.
// 
// 1     22/05/02 15:15 Len
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1997 - 2002 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All 
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors 
// shall not be liable for any damages suffered by licensee as a result of 
// using, modifying or distributing the software or its derivatives. In no
// event will JetByte Limited be liable for any lost revenue, profit or data,
// or for direct, indirect, special, consequential, incidental or punitive
// damages, however caused and regardless of the theory of liability, arising 
// out of the use of or inability to use software, even if JetByte Limited 
// has been advised of the possibility of such damages.
//
// This software is not designed or intended for use in on-line control of 
// aircraft, air traffic, aircraft navigation or aircraft communications; or in 
// the design, construction, operation or maintenance of any nuclear 
// facility. Licensee represents and warrants that it will not use or 
// redistribute the Software for such purposes. 
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Lint options
//
//lint -save
//
//lint +libh(NmInterfaces.h) "library" header that we can do nothing with
//
//lint -esym(578, CNmConferenceManager::Exception) hides CNotify::Exception
//lint -esym(1509, TNotify) base class dtor not virtual (private inheritance)
//lint -esym(1704, CNmConferenceManager::CNmConferenceManager) private copy ctor
//
///////////////////////////////////////////////////////////////////////////////

#include "NmInterfaces.h"

#include "NmException.h"

#include "JetByteTools\COMTools\TNotify.h"
#include "JetByteTools\COMTools\UsesCOM.h"

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools::NetMeeting
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {
namespace NetMeeting {

///////////////////////////////////////////////////////////////////////////////
// CNmConferenceManager
///////////////////////////////////////////////////////////////////////////////

class CNmConferenceManager : 
   private COM::CUsesCOM, 
   private COM::TNotify<INmManagerNotify, &IID_INmManagerNotify>
{
   public :

		class Exception : public CNmException
		{
			friend class CNmConferenceManager;

			private :

				Exception(LPCTSTR pWhere, HRESULT hr) 
					: CNmException(pWhere, hr) {}

		};

      CNmConferenceManager();
		~CNmConferenceManager();

      //lint -e{1930} conversion operator
		operator INmManager *();

		static bool IsNmInstalled();
		static HRESULT CheckInstalled();

		// Implement INmManager

		void Initialize(
			ULONG &options, 
			ULONG &uChannelCaps);

		INmCall *CallConference(
			NM_CALL_TYPE callType,
			NM_ADDR_TYPE addressType,
			LPCTSTR pAddress, 
			LPCTSTR pName, 
			LPCTSTR pPassword = _T("") );
	
		INmCall *CreateCall();
		
		INmConference *CreateConference(
			LPCTSTR pName, 
			//LPCTSTR pPassword,
			ULONG channelCapabilities);

		//IEnumCall EnumCall();
		
		//IEnumConference EnumConference();
		
		INmSysInfo *GetSysInfo();

		// Implement INmManagerNotify
	
		HRESULT STDMETHODCALLTYPE NmUI(CONFN confn);
		HRESULT STDMETHODCALLTYPE ConferenceCreated(INmConference *pConference);
		HRESULT STDMETHODCALLTYPE CallCreated(INmCall *pCall);

	private : 
		
		// Don't implement - restrict copying
		CNmConferenceManager(const CNmConferenceManager &rhs);
		CNmConferenceManager &operator=(const CNmConferenceManager &rhs);

		INmManager *m_pIManager;
};

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools::NetMeeting
///////////////////////////////////////////////////////////////////////////////

} // End of namespace NetMeeting
} // End of namespace JetByteTools 

///////////////////////////////////////////////////////////////////////////////
// Lint options
//
//lint -restore
//
///////////////////////////////////////////////////////////////////////////////

#endif // JETBYTE_TOOLS_NM_CONFERENCE_MANAGER_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
