#if defined (_MSC_VER) && (_MSC_VER >= 1020)
#pragma once
#endif

#ifndef JETBYTE_TOOLS_WIN32_OLE_STRING_INCLUDED__
#define JETBYTE_TOOLS_WIN32_OLE_STRING_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
//
// File           : $Workfile: Olestring.h $
// Version        : $Revision: 1 $
// Function       : 
//
// Author         : $Author: Len $
// Date           : $Date: 22/05/02 9:12 $
//
// Notes          : 
//
// Modifications  :
//
// $Log: /JetByteTools/Win32Tools/Olestring.h $
// 
// 1     22/05/02 9:12 Len
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 1997 - 2002 JetByte Limited.
//
// JetByte Limited grants you ("Licensee") a non-exclusive, royalty free, 
// licence to use, modify and redistribute this software in source and binary 
// code form, provided that i) this copyright notice and licence appear on all 
// copies of the software; and ii) Licensee does not utilize the software in a 
// manner which is disparaging to JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All 
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors 
// shall not be liable for any damages suffered by licensee as a result of 
// using, modifying or distributing the software or its derivatives. In no
// event will JetByte Limited be liable for any lost revenue, profit or data,
// or for direct, indirect, special, consequential, incidental or punitive
// damages, however caused and regardless of the theory of liability, arising 
// out of the use of or inability to use software, even if JetByte Limited 
// has been advised of the possibility of such damages.
//
// This software is not designed or intended for use in on-line control of 
// aircraft, air traffic, aircraft navigation or aircraft communications; or in 
// the design, construction, operation or maintenance of any nuclear 
// facility. Licensee represents and warrants that it will not use or 
// redistribute the Software for such purposes. 
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Lint options
//
//lint -save
//
///////////////////////////////////////////////////////////////////////////////

#pragma warning(disable: 4201)   // nameless struct/union

#ifndef _INC_TCHAR
#include <tchar.h>
#endif

#ifndef __wtypes_h__
#include <wtypes.h>
#endif

#pragma warning(default: 4201)

#pragma warning(disable: 4710)   // function not expanded

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools::Win32
///////////////////////////////////////////////////////////////////////////////

namespace JetByteTools {
namespace Win32 {

///////////////////////////////////////////////////////////////////////////////
// COleString
///////////////////////////////////////////////////////////////////////////////

class COleString
{
   public :

      // Construction and destruction

      COleString(LPCOLESTR lpOleString);
      COleString(LPCSTR lpString);
      
      virtual ~COleString();

		// Access

		const char *GetAs_char() const;
		const wchar_t *GetAs_wchar_t() const;
		const TCHAR *GetAs_tchar() const;

      // Conversion

      operator const char *() const;
      operator const wchar_t *() const; 

      // Duplication
      
      wchar_t *DuplicateAs_wchar_t() const;
      char *DuplicateAs_char() const;
      TCHAR *DuplicateAs_tchar() const;

   private :

      bool m_bOleString;

      mutable LPOLESTR m_lpOleString;
      mutable char *m_lpString;
};

class CNonConstOleString : public COleString
{
   public :

      CNonConstOleString(LPCOLESTR lpOleString) : COleString(lpOleString) {}
      CNonConstOleString(LPCSTR lpString) : COleString(lpString) {}

      // Conversion for non-const correct code
      // Handle with care...

      operator char *() { return (char*)operator const char *(); }
      operator wchar_t *() { return (wchar_t*)operator const wchar_t *(); } 
};

typedef COleString _O;

typedef CNonConstOleString _ONCC;

///////////////////////////////////////////////////////////////////////////////
// Namespace: JetByteTools::Win32
///////////////////////////////////////////////////////////////////////////////

} // End of namespace Win32
} // End of namespace JetByteTools 

///////////////////////////////////////////////////////////////////////////////
// Lint options
//
//lint -restore
//
///////////////////////////////////////////////////////////////////////////////

#endif // JETBYTE_TOOLS_WIN32_OLE_STRING_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file
///////////////////////////////////////////////////////////////////////////////
